#include <WiFiClient.h> 
#include <WiFiClientSecure.h>
#include <PubSubClient.h> 

void connectAWSIoT();

void mqttCallback (char* topic, byte* payload, unsigned int length);

const char* ssid = "aquario";
const char* password = "aquario_virtual";

const char *endpoint ="a1dl08fmj981lr.iot.us-east-1.amazonaws.com";
const int port = 8883;
const char *pubTopic ="$aws/things/lamp/shadow/update";
const char *subTopic ="$aws/things/lamp/shadow/update/accepted";

const char* rootCA ="-----BEGIN CERTIFICATE-----\n" \
"MIIDQTCCAimgAwIBAgITBmyfz5m/jAo54vB4ikPmljZbyjANBgkqhkiG9w0BAQsF\n" \
"ADA5MQswCQYDVQQGEwJVUzEPMA0GA1UEChMGQW1hem9uMRkwFwYDVQQDExBBbWF6\n" \
"b24gUm9vdCBDQSAxMB4XDTE1MDUyNjAwMDAwMFoXDTM4MDExNzAwMDAwMFowOTEL\n" \
"MAkGA1UEBhMCVVMxDzANBgNVBAoTBkFtYXpvbjEZMBcGA1UEAxMQQW1hem9uIFJv\n" \
"b3QgQ0EgMTCCASIwDQYJKoZIhvcNAQEBBQADggEPADCCAQoCggEBALJ4gHHKeNXj\n" \
"ca9HgFB0fW7Y14h29Jlo91ghYPl0hAEvrAIthtOgQ3pOsqTQNroBvo3bSMgHFzZM\n" \
"9O6II8c+6zf1tRn4SWiw3te5djgdYZ6k/oI2peVKVuRF4fn9tBb6dNqcmzU5L/qw\n" \
"IFAGbHrQgLKm+a/sRxmPUDgH3KKHOVj4utWp+UhnMJbulHheb4mjUcAwhmahRWa6\n" \
"VOujw5H5SNz/0egwLX0tdHA114gk957EWW67c4cX8jJGKLhD+rcdqsq08p8kDi1L\n" \
"93FcXmn/6pUCyziKrlA4b9v7LWIbxcceVOF34GfID5yHI9Y/QCB/IIDEgEw+OyQm\n" \
"jgSubJrIqg0CAwEAAaNCMEAwDwYDVR0TAQH/BAUwAwEB/zAOBgNVHQ8BAf8EBAMC\n" \
"AYYwHQYDVR0OBBYEFIQYzIU07LwMlJQuCFmcx7IQTgoIMA0GCSqGSIb3DQEBCwUA\n" \
"A4IBAQCY8jdaQZChGsV2USggNiMOruYou6r4lK5IpDB/G/wkjUu0yKGX9rbxenDI\n" \
"U5PMCCjjmCXPI6T53iHTfIUJrU6adTrCC2qJeHZERxhlbI1Bjjt/msv0tadQ1wUs\n" \
"N+gDS63pYaACbvXy8MWy7Vu33PqUXHeeE6V/Uq2V8viTO96LXFvKWlJbYK8U90vv\n" \
"o/ufQJVtMVT8QtPHRh8jrdkPSHCa2XV4cdFyQzR1bldZwgJcJmApzyMZFo6IQ6XU\n" \
"5MsI+yMRQ+hDKXJioaldXgjUkK642M4UwtBV8ob2xJNDd2ZhwLnoQdeXeGADbkpy\n" \
"rqXRfboQnoZsG4q5WTP468SQvvG5\n" \
"-----END CERTIFICATE-----\n";

const char* certificate ="-----BEGIN CERTIFICATE-----\n" \
"MIIDWjCCAkKgAwIBAgIVAOqviqfRCWkOjPQ6f8KJE1MXQXUCMA0GCSqGSIb3DQEB\n" \
"CwUAME0xSzBJBgNVBAsMQkFtYXpvbiBXZWIgU2VydmljZXMgTz1BbWF6b24uY29t\n" \
"IEluYy4gTD1TZWF0dGxlIFNUPVdhc2hpbmd0b24gQz1VUzAeFw0yMTA3MzAxMTU1\n" \
"MjNaFw00OTEyMzEyMzU5NTlaMB4xHDAaBgNVBAMME0FXUyBJb1QgQ2VydGlmaWNh\n" \
"dGUwggEiMA0GCSqGSIb3DQEBAQUAA4IBDwAwggEKAoIBAQC6PPAhJ/FByBdHFwls\n" \
"Wj458/HaIMwYsaafTuMJjUCo+GEQaIIYYKbwnuy5efD/zhvLoPmiRQM+eBV3OmxL\n" \
"Hm96NobTqtpMpSpin8fSfC6xZa65nsMkiSEIFhwY4ousglWDXpLXMvd5PanmuBj2\n" \
"JM0aWL7lOK1UVCf+xcJfM14nKnAJMg6/kc5FyQe96NFrLu5YWUJp0YzyvJSs/n/X\n" \
"GOFYq0CD4EBjNZ8AJ6NrFtVzg5hgVFjUEZQf30nvFjKv94Wk6KNGLLgaPZGh3E5Y\n" \
"/g0vXPIObY7ry+i3ZFfsyLXD8uM21nHqCE8TO/0dKT2BHhmy/xleLLh577U12sQe\n" \
"9UfJAgMBAAGjYDBeMB8GA1UdIwQYMBaAFIsf5so9vvcPyvZx9oMOuKpzusQeMB0G\n" \
"A1UdDgQWBBSwyOjirj8HlluOcxmocRBxeGUwEzAMBgNVHRMBAf8EAjAAMA4GA1Ud\n" \
"DwEB/wQEAwIHgDANBgkqhkiG9w0BAQsFAAOCAQEAQlkyQ/AqAWDG1Cfal0ZZy6sZ\n" \
"aWJOrEZA5y6ehMEcSb8yZp4sugvWGWPLaxpjjcuzn32RszSY4qVgDYQubA37C0dn\n" \
"FWGJOsxf6wEtXeCvky02N8EzHl4/OAYsn12/zbWFo9Qdk0/MhFeaC2m4UMFEImBc\n" \
"SMJiZPI9UcQikRmCpyzwbBrXlDviYkY61KCVla2TaXGnfcR+yXUrcUjWvb+WZRyw\n" \
"oDCZnQEPln9fWkEtE6y2suBLRqE4DFdg62+ffE8yRsq2Iay4Ip/r0Eq2DC3P1GRm\n" \
"DoFH7GdNbMPFhzkxe1KFbr/v1AqKPnf0hzjw7sCmYnXGMCD3GQL0yuqc6RTygg==\n" \
"-----END CERTIFICATE-----\n";

const char* privateKey ="-----BEGIN RSA PRIVATE KEY-----\n" \
"MIIEpQIBAAKCAQEAujzwISfxQcgXRxcJbFo+OfPx2iDMGLGmn07jCY1AqPhhEGiC\n" \
"GGCm8J7suXnw/84by6D5okUDPngVdzpsSx5vejaG06raTKUqYp/H0nwusWWuuZ7D\n" \
"JIkhCBYcGOKLrIJVg16S1zL3eT2p5rgY9iTNGli+5TitVFQn/sXCXzNeJypwCTIO\n" \
"v5HORckHvejRay7uWFlCadGM8ryUrP5/1xjhWKtAg+BAYzWfACejaxbVc4OYYFRY\n" \
"1BGUH99J7xYyr/eFpOijRiy4Gj2RodxOWP4NL1zyDm2O68vot2RX7Mi1w/LjNtZx\n" \
"6ghPEzv9HSk9gR4Zsv8ZXiy4ee+1NdrEHvVHyQIDAQABAoIBABiAV98k0BqlZlqV\n" \
"70lv/evF6jWWRwOgq5kd2cSx7qXMN4jfFu56GLxjTCWCo3Aj/4gkn3L3vVuElN5g\n" \
"s0qWsHfVoJtMSPf4asEa4EES0VnJVNlax7WQzOWxcvTbKSEC7Jkh4hOpwuESeb2+\n" \
"zpnjcZBbyJGDiVok0DY2ckHwEhz4wNcaVueKV39BIoVyRct4MbDEBdzz1qm0KjlN\n" \
"VXR5OCIl/oIaf41D5Jh/R4J0Kdk5Yvj6DolC7rj7ZLQhB5I56bmtxk8plVQWJBoc\n" \
"k/Fbl63NX2YQ/92sR9X+8xiA1cjOIdV3Sj/miQtOYAKiwt4hYGqX1lVlCUqlCSHs\n" \
"HPyqibkCgYEA4GshHaMIjmez9hGknRsFJZqMNnx0mJRyKEfzqvgJcS4EMBzNTB/T\n" \
"VK1MBKvuJ3JXGWwTjpRDc4P/6D5nbd54VPE5rwKoYOz7PEdr/CXyIhTxOqVsCbn+\n" \
"DJcHnicEg/jdFxz1o6UPp3RAwKYZ5UibHAXYLX/4oAL+t8hBt8TjKAMCgYEA1HJT\n" \
"RbxbrAQRknUTeTR9t5xRRhfzFg1Tv6pa+d9lhoNtJWvaq1kTQXbJzhU27DJdmYwB\n" \
"YivPE/Z80LDtmttPcqENUGX2V11gBPD0U+xlBXy6TcjWlqIXzmaWxRJQJtFxDMf0\n" \
"pem8Wl5UoLuf1o+tuv19Wv8PnTHtuwJvGMyTRUMCgYEAlTCi40Du/zyRtpQkCw1b\n" \
"bpQ/gjlaidSlz4GFy7L5E/SzdAixslm19CUA1Fo4CKFKpevjVHXcIX8vMQXLXI75\n" \
"D/8NifsKVOU2X+xbLVVMkru5YnN2T0EGUvhUaB8oMVPQJv1pj1C8B2aRZYEG1hZe\n" \
"h1KbVCQu9LEJBMRsa+7H1GECgYEAp+MdGZwL2flxJYtt8zffLc3TkI/2o3OuvmXS\n" \
"9WpsoguUoqEEMqr3A6HrQvgS6j+3JlO0+C7ku8LrykQ30UwFEfJiQioBrfL1oZIF\n" \
"k5jaEKcL19KienHoXE1IUr7xJmwXaeFO3hrDpaqsOEVtwDLVOVN/z/yHC1Pcqg/3\n" \
"WeK5c18CgYEAk1/fXHFMexgRhSD0qRwwVxWRSoygrcQ45YIxMwwBZZgNfLtgWzuo\n" \
"2bG9uM7vIyeIoHXe4pd1SC/zcAFiA5qZ62l5SHdL2p7WFFzsz4pW9NmrCPlX2Dl9\n" \
"kbMLKV3fuBvdm6FGgbfWpADEPQh+98UsndV5G7vFf8o72k8yoV7dUeE=\n" \
"-----END RSA PRIVATE KEY-----\n";

WiFiClientSecure httpsClient;
PubSubClient mqttClient(httpsClient);

void setup() {
      Serial.begin(115200);// Start WiFi     
      Serial.println("Connecting to ");    
      Serial.print(ssid);    
      WiFi.begin(ssid, password);
      while(WiFi.status()!= WL_CONNECTED)
      {        
          delay(500);        
          Serial.print(".");
      }    
      Serial.println("\nConnected.");
      // Configure MQTT Client    
      httpsClient.setCACert(rootCA);    
      httpsClient.setCertificate(certificate);    
      httpsClient.setPrivateKey(privateKey);    
      
      mqttClient.setServer(endpoint, port);    
      mqttClient.setCallback(mqttCallback);    
}

void connectAWSIoT(){
  while(!mqttClient.connected())
  {
    if(mqttClient.connect("lamp"))
    {            
      Serial.println("Connected.");
      int qos =0;
      mqttClient.subscribe(subTopic, qos);
      Serial.println("Subscribed.");
    }
    else {           
      Serial.print("Failed. Error state=");            
      Serial.print(mqttClient.state());// Wait 5 seconds before retrying             
      delay(5000);
    }
  }
}

long messageSentAt =0;
int dummyValue =0;
char pubMessage[128];

void mqttCallback (char* topic, byte* payload, unsigned int length)
{ 
  Serial.print("Received. topic=");    
  Serial.println(topic);
  for(int i =0; i < length; i++)
    Serial.print((char)payload[i]);
    Serial.print("\n");
}

void mqttLoop()
{ 
  if(!mqttClient.connected())
  {        
      connectAWSIoT();
  }    
  mqttClient.loop();
  long now = millis();
  if(now - messageSentAt >5000)
     {        
          messageSentAt = now;        
          sprintf(pubMessage,"{\"state\": {\"desired\":{\"foo\":\"%d\"}}}",dummyValue++);        
          Serial.print("Publishing message to topic ");        
          Serial.println(pubTopic);        
          Serial.println(pubMessage);        
          mqttClient.publish(pubTopic, pubMessage);        
          Serial.println("Published.");
     }
}

void loop() {
  // put your main code here, to run repeatedly:
    mqttLoop();
}
